package converter;

public class Automaton {
  public Token tk;
  public Lexer lr;
  public LexTab lt;
  public Buffer bf;
  int isym;
  char sym;
  private char state = 'I';
  String s;
  public Automaton(Lexer ll) {
    bf = new Buffer();
    lt = new LexTab();
    lr = ll;
  }
  public LexTab getLexTab(){return lt;}

  public Token nextToken() throws LexException{
    while(true){
      if ( (isym = lr.nextSym()) == -1)return Token.Toknull;
      sym = (char) isym;
      switch (state) {
        case 'I':
          if (Character.isLetter(sym)) {
            bf.startBuf();
            bf.addBuf(sym);
            state = 'A';
            break;
          }
          else if (sym == '{' || sym == '}' || sym == ':' || sym == ';' ||
                   sym == ',' || sym == '(' || sym == ')' || sym == '=' ||
                   sym == '|' || sym == '&' || sym == '~') {
               tk = lt.makeSymToken(sym);
               return tk;
              }
              else {
                   System.out.println(sym + "   "+ lr.linenum +"   "+ lr.symnum);
                   throw new LexException("Automaton.nextToken():   ");}
        case 'A':  if(Character.isLetterOrDigit(sym)){
                     bf.addBuf(sym);
                     state = 'A';
                     break;
                   }
                   else if(sym == ':' || sym == '=' || sym == '&' || sym == '|' || sym == ')'
                     || sym == ',' || sym == ';' ){
                   tk = lt.makeIdnToken(bf.getAll());
                   lr.restore(sym);
                   state = 'I';
                   return tk;
                   }
                   else { System.out.println(sym + "   "+ lr.linenum +"   "+ lr.symnum);
                     throw new LexException("Automaton.nextToken() :     ");
                   }
          default: throw new LexException("Automaton.nextToken() :    ");
      }//end switch

    } // end while

  }
}
